/**
 * A class in the MiniJava programming language
 */
package minijava;

import minijava.analysis.*;
import minijava.node.*;
import java.util.*;
 
public class Class{

    String id;
    Hashtable methods;
    Hashtable globals;
    String parent;
    Node type;
    
    public Class(String id, String p) {
	this.id = id;
	parent = p;
	type = new AIdentifierType();
	methods = new Hashtable();
	globals = new Hashtable();
    }
    
    public Class() {}
    
    public String getId(){ return id; }
    
    public Node getType(){ return type; }
    
    public String getParent() {
	return parent;
    }	    
    
    public boolean addMethod(String id, Node type) {
	if(containsMethod(id)) 
	    return false;       
	else {
	    methods.put(id, new Method(id, type));
	    return true;
	}
    }
	
    public Enumeration getMethods(){
	return methods.keys();
    }
    
    public Method getMethod(String id) {
	if(containsMethod(id)) 
	    return (Method)methods.get(id);
	else 
	    return null;
    }
	
    public boolean addVariable(String id, Node type) {
	if(globals.containsKey(id)) 
	    return false;
	else{
	    globals.put(id, new Variable(id, type));
	    return true;
	}
    }
    
    public Variable getVariable(String id) {
	if(containsVariable(id)) 
	    return (Variable)globals.get(id);
	else 
	    return null;
    }
    
    public boolean containsVariable(String id) {
	return globals.containsKey(id);
    }
    
    public boolean containsMethod(String id) {
	return methods.containsKey(id);
    }
    
}



