package minijava; // the package

import minijava.node.*;
import minijava.lexer.*;
import minijava.parser.*;

import java.io.*;

public class Main{
    public static void main(String[] args){
		System.out.println("Hello Compiler");
		Lexer lex;
        
		try{
			// create a new parser
			if (args.length > 0){
				// use file argument
				lex = new Lexer(
						new PushbackReader(
						  	  new BufferedReader(
							      new FileReader(args[0])), 1024));
			}
			else{
				// read from System.in
				lex = new Lexer(
							new PushbackReader(
								new InputStreamReader(System.in), 1024));
			}
			
			// connect lexer with parser
			Parser p = new Parser(lex);
			// parse the tree and get abstract syntax tree (ast) back
			Start ast = p.parse();
			//ast.apply(new CalcInterpreter());
		}
		catch (Exception e){
			// write to error output
			System.err.println(e);
		}
        System.out.println("Done compiler");
	}
}
