/**
 * A method in the MiniJava programming language
 */
package minijava;

import minijava.analysis.*;
import minijava.node.*;
import java.util.*;

public class Method{
	
    protected String id;
    protected Node type;
    protected LinkedList params;
    protected Hashtable vars;
    
    public Method(String id, Node type) {
	this.id = id;
	this.type = type;
	vars = new Hashtable();
	params = new LinkedList();
    }
    
    public String getId() { return id; }
    
    public Node getType() { return type; }
    
    
    public boolean addParameter(String id, Node type) {
	if(containsParameter(id)){
	    return false;
	}
	else {
	    params.add(new Variable(id, type));
	    return true;
	}
    }
    
    public Iterator getParameters(){
        return params.listIterator();
    }
    
    public Variable getParameterAt(int i){
	if (i < params.size()){
	    return (Variable)params.get(i);
	}
	else{
	    return null;
	}
    }

    public boolean addVariable(String id, Node type) {
	if(vars.containsKey(id)){
	    return false;
	}
	else{
	    vars.put(id, new Variable(id, type));
	    return true;
	}
    }
    
    public boolean containsVariable(String id){
	return vars.containsKey(id);
    }
    
    public boolean containsParameter(String id) {
	for (int i = 0; i< params.size(); i++)
	    if (((Variable)params.get(i)).id.equals(id))
		return true;
	return false;
    }
    
    public Variable getVariable(String id) {
	if(containsVariable(id)) 
	    return (Variable)vars.get(id);
	else 
	    return null;
    }
    
    public Variable getParameter(String id) {
	for (int i = 0; i< params.size(); i++)
	    if (((Variable)params.get(i)).id.equals(id))
		return (Variable)(params.get(i));
	
	return null;
    }
}

